unit Timeline;
{
www.lendasoft.narod.ru
TTimeline version 2.0

AntiAliasLevel -  .
ForeColor -   .
BackColor -    .
BackIslessFore -    " "  " ".
Kind -    .
ToChangeMouse - True  , False  .
MouseShift -      .
              ,      ,
                 ,
                   
             .

IsMouseEntering - True  , Fasle - 

OnMouseEnter -  
OnMouseLeave -  
OnChange -  
}

interface

uses
SysUtils,
//types,
Classes,
Messages,
windows,
//{$IFDEF LINUX}QGraphics, QControls;{$ENDIF}
Graphics,
Controls;


type
    pRGBArray  =  ^TRGBArray;
    TRGBArray  =  ARRAY[0..65536] OF TRGBTriple;

  TGaugeKind = ( gkHorizontalBar, gkVerticalBar);

//  TOnMouse = procedure(Sender: TObject) of object;
    TMouseMoveEventEx = procedure(Sender: TObject; Shift: TShiftState;
    X, Y: Integer;Pos:integer) of object;
    TMouseDownEventEx = procedure(Sender: TObject; Shift: TShiftState;
    X, Y: Integer;Pos:integer) of object;

  TTimeLine = class({TCustomControl{}TGraphicControl)
  private
    TheCurrentImage: TBitmap;// /   .
    FMinValue: integer;
    FMaxValue: integer;
    FCurValue: integer;
    FKind: TGaugeKind;
    FForeColor: TColor;
    FBackColor: TColor;
    FAntiAliasLevel: integer;
    FOnChange: TNotifyEvent;
    FOnMouseEnter: TNotifyEvent;
    FOnMouseLeave: TNotifyEvent;
    FIsMouseEntering: boolean;
    FToChangeMouse: boolean;
    FMouseShift: TShiftState;
    FBackIslessFore: Integer;
    FStep: integer;
    FToChangeMouseMove: boolean;
    FOnMouseMove: TMouseMoveEventEx;
    FOnMouseDown: TMouseDownEventEx;
    procedure PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
    procedure SetGaugeKind(Value: TGaugeKind);
    procedure SetForeColor(Value: TColor);
    procedure SetBackColor(Value: TColor);
    procedure SetMinValue(Value: integer);
    procedure SetMaxValue(Value: integer);
    procedure SetProgress(Value: integer);
    function  GetPercentDone: Longint;
    procedure SetAntiAliasLevel(const Value: integer);
    procedure SetToChangeMouse(const Value: boolean);
    procedure SetMouseShift(const Value: TShiftState);
    procedure SetBackIslessFore(const Value: Integer);
    procedure SetToChangeMouseMove(const Value: boolean);
    procedure SetOnMouseMove(const Value: TMouseMoveEventEx);
    procedure SetOnMouseDown(const Value: TMouseDownEventEx);
  protected
    Pain:cardinal;
    Function GetProgressLen:integer;reintroduce;overload;
    //     
    Function GetProgressFuture(x,y:integer):integer;reintroduce;overload;
    procedure Paint;override;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer) ;override;
    procedure MouseDown(Button: TMouseButton;Shift: TShiftState; X, Y: Integer);override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property PercentDone: Longint read GetPercentDone;
    Property IsMouseEntering:boolean read FIsMouseEntering;
    procedure DecStep;
    procedure IncStep;
  published
    property Step:integer read FStep write FStep;
    property Enabled;
    property Align;
    property Anchors;
    property AntiAliasLevel:integer read FAntiAliasLevel write SetAntiAliasLevel;
    property ToChangeMouse:boolean read FToChangeMouse write SetToChangeMouse;
    property ToChangeMouseMove:boolean read FToChangeMouseMove write SetToChangeMouseMove;
    property MouseShift:TShiftState read FMouseShift write SetMouseShift;
    property BackColor: TColor read FBackColor write SetBackColor default clWhite;
    property Color;
    property Constraints;
    property ForeColor: TColor read FForeColor write SetForeColor default clBlack;
    property BackIslessFore:Integer read FBackIslessFore write SetBackIslessFore;
    property Font;
    property Kind: TGaugeKind read FKind write SetGaugeKind default gkHorizontalBar;
    property MinValue: integer read FMinValue write SetMinValue default 0;
    property MaxValue: integer read FMaxValue write SetMaxValue default 100;
    property ParentColor;
    property ParentShowHint;
    property PopupMenu;
    property Progress: integer read FCurValue write SetProgress;
    property ShowHint;
    property Visible;
//    property Ctl3D;

    property OnClick;
    property OnDblClick;
    property OnContextPopup;
    property OnMouseMove:TMouseMoveEventEx read FOnMouseMove write SetOnMouseMove;
//    property OnMouseWheel;//: TMouseWheelEvent read FOnMouseWheel write FOnMouseWheel;
//    property OnMouseWheelUp;
//    property OnMouseWheelDown;
    property OnMouseDown:TMouseDownEventEx read FOnMouseDown write SetOnMouseDown;
    property OnMouseUp;
    property OnMouseEnter: TNotifyEvent read FOnMouseEnter write FOnMouseEnter;
    property OnMouseLeave: TNotifyEvent read FOnMouseLeave write FOnMouseLeave;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
  end;

//procedure AntiAliasRect(clip: tbitmap; XOrigin, YOrigin, XFinal, YFinal: Integer;TransColor:TColor=clNone);
  procedure Register;

implementation

uses Consts;

procedure Register;
begin
RegisterComponents('LendaSoft', [TTimeLine]);
end;

//    
Function TTimeLine.GetProgressLen:integer;
begin
If MaxValue<=0 then result:=0 else
 case fKind of
  gkHorizontalBar: result := trunc(progress*(1+Width) /MaxValue);
  gkVerticalBar  : result := trunc(progress*(1+height)/MaxValue);
 end;
end;


function Min(a, b: integer): integer;
begin
  if a < b then result := a
  else result := b;
end;

function Max(a, b: integer): integer;
begin
  if a > b then result := a
  else result := b;
end;

{procedure AntiAliasRect(clip: tbitmap; XOrigin, YOrigin,
  XFinal, YFinal: Integer;TransColor:TColor=clNone);
var Memo,x,y: Integer;
    p0,p1,p2:pbytearray;

begin
   if XFinal<XOrigin then begin Memo:=XOrigin; XOrigin:=XFinal; XFinal:=Memo; end;  (* Inversion des valeurs   *)
   if YFinal<YOrigin then begin Memo:=YOrigin; YOrigin:=YFinal; YFinal:=Memo; end;  (* si diffrence ngative*)
   XOrigin:=max(1,XOrigin);
   YOrigin:=max(1,YOrigin);
   XFinal:=min(clip.width-2,XFinal);
   YFinal:=min(clip.height-2,YFinal);
   clip.PixelFormat :=pf24bit;

   for y:=YOrigin to YFinal do begin
    p0:=clip.ScanLine [y-1];
    p1:=clip.scanline [y];
    p2:=clip.ScanLine [y+1];
    for x:=XOrigin to XFinal do begin
    if  TransColor=clnone then
      begin
       p1[x*3]:=(p0[x*3]+p2[x*3]+p1[(x-1)*3]+p1[(x+1)*3])div 4;
       p1[x*3+1]:=(p0[x*3+1]+p2[x*3+1]+p1[(x-1)*3+1]+p1[(x+1)*3+1])div 4;
       p1[x*3+2]:=(p0[x*3+2]+p2[x*3+2]+p1[(x-1)*3+2]+p1[(x+1)*3+2])div 4;
      end
      else
      begin
     //    
//     TransColor:=  TransColor shl 8;
//     TransColor:=  transcolor shr 8;
     TransColor:=ColorToRGB(TransColor);
     if TransColor<> RGB(p1[x*3+2],p1[x*3+1],p1[x*3]) then
      begin
       p1[x*3]:=  (p0[x*3]+  p2[x*3]+  p1[(x-1)*3]+  p1[(x+1)*3])  div 4;
       p1[x*3+1]:=(p0[x*3+1]+p2[x*3+1]+p1[(x-1)*3+1]+p1[(x+1)*3+1])div 4;
       p1[x*3+2]:=(p0[x*3+2]+p2[x*3+2]+p1[(x-1)*3+2]+p1[(x+1)*3+2])div 4;
      end
      else
      begin
       TransColor:=0;
      end;
      end;  

      end;
   end;
end; }

{ This function solves for x in the equation "x is y% of z". }
function SolveForX(Y, Z: Longint): Longint;
begin
  Result := Longint(Trunc( Z * (Y * 0.01) ));
end;

{ This function solves for y in the equation "x is y% of z". }
function SolveForY(X, Z: Longint): Longint;
begin
  if Z = 0 then Result := 0
  else Result := Longint(Trunc( (X * 100.0) / Z ));
end;

{ TGauge }

constructor TTimeLine.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csFramed, csOpaque];
  { default values }
  FAntiAliasLevel:=0;
  FMinValue := 0;
  FMaxValue := 100;
  FCurValue := 0;
  FKind := gkHorizontalBar;
//  FShowText := True;
//  FBorderStyle := bsSingle;
  FForeColor := clBlack;
  FBackColor := clWhite;
  FToChangeMouse:=true;
  Width := 100;
  Height := 100;
  FCurValue:=50;
  FBackIslessFore:=2;
  TheCurrentImage:= TBitmap.Create;
//  TheCurrentImage.Modified:=true;
end;

function TTimeLine.GetPercentDone: Longint;
begin
  Result := SolveForY(FCurValue - FMinValue, FMaxValue - FMinValue);
end;

procedure TTimeLine.Paint;
//var
//  TheImage: TBitmap;
begin
//     
  with Canvas do
  begin
//    TheCurrentImage := TBitmap.Create;
    try
      //   
      //TheCurrentImage.Canvas.Brush.Color:=Color;
      {if TheCurrentImage.Height<>Height then}
      //  1     (    )
      TheCurrentImage.Height := Height+2;
      {if TheCurrentImage.Width<>Width then}
      TheCurrentImage.Width := Width+2;
      try
        PaintAsBar(TheCurrentImage,TheCurrentImage.Canvas.ClipRect {ClientRect});
      finally
      end;
{ TODO :     }
      //  
//      inc(pain);
//      TheCurrentImage.Canvas.TextOut(0,0,inttostr(pain));

      Canvas.CopyMode := cmSrcCopy;
      //   
     // Canvas.Draw(0, 0, TheCurrentImage);
      BitBlt(Canvas.Handle,0,0,width,height,
      theCurrentImage.Canvas.Handle,1,1,SRCCOPY);
    finally
      //TheCurrentImage.Modified:=true;
      //TheImage.Destroy;
    end;
  end;
end;

Procedure InflateRectEx(var Rec:TRect;dx,dy:integer);
begin
inc(Rec.Left,dx);
dec(Rec.Right,dx);
inc(rec.Top,dy);
dec(rec.Bottom,dy);
end;

//   3 
procedure AntiAliasRect(clip: graphics.tbitmap; TransColor:TColor=clNone);
type bi = array [0..3] of byte;
//rz2 = array of rz;
var//  s0,s1,s2:rz2;
Memo,x,x_3,y: Integer;
    p0,p1,p2:pbytearray;
    g0,g1,g2:pRGBArray;
    gg:TRGBTriple;
    XFinal, YFinal: Integer;
    pc:pchar;
    rep,rt,gt,bt:byte;
tw:word;
BPSl:integer;
{type
bp =record
 case byte of
 0: (by :array [0..3] of byte);
 1: (wo :array [0..1] of word);
 2: (lo :LongInt);
end;}
var p:^bi;
begin
 if TransColor < 0 then TransColor := GetSysColor(TransColor and $000000FF);

 XFinal:=clip.width-2;
//    
// BPSl:=BytesPerScanline(clip.width);
 BPSl := (((XFinal+2)*24)+31) and not 31;
 BPSl := BPSl div 8;

 YFinal:=clip.height-2;
 clip.PixelFormat :=pf24bit;


 p1:=clip.scanline [0];
// p2:=clip.ScanLine [1];
 p2:=p1;
 dec( pchar(p2),BPSl );

 for y:=1 to YFinal do begin   //10%
  p0:=p1;p1:=p2;
  dec(pchar(p2),BPSl);

  for x:=1 to XFinal do begin
  x_3:=x*3;
  p:=@p1[x_3];
//  if TransColor<>(p1[x_3+2] or (p1[x_3+1] shl 8) or (p1[x_3] shl 16))  then
  if (bi(TransColor)[0]<>p[2])or(bi(TransColor)[1]<>p[1])
      or(bi(TransColor)[2]<>p[0])  then
   begin   //60-70%
    p1[x_3]  :=(p0[x_3  ]+ p2[x_3  ]+ p1[x_3-3]+ p1[x_3+3]) div 4;
    p1[x_3+1]:=(p0[x_3+1]+ p2[x_3+1]+ p1[x_3-2]+ p1[x_3+4]) div 4;
    p1[x_3+2]:=(p0[x_3+2]+ p2[x_3+2]+ p1[x_3-1]+ p1[x_3+5]) div 4;
   end
  end;
 end;
end;

procedure TTimeLine.PaintAsBar(AnImage: TBitmap; PaintRect: TRect);
var
  Prg,i:integer;
begin
  AnImage.Canvas.lock;
  with AnImage.Canvas do
  begin
    //   ->>  Paint   
    brush.Color:=color;
    FillRect(PaintRect);

//      (  )
//     
// (  )
    prg:=GetProgressLen;

//--- Back
    Brush.Color := BackColor;
    if fkind=gkHorizontalBar then
      FillRect(Rect(prg+1,1+FBackIslessFore,width+1,height+1-FBackIslessFore))
     else
      FillRect(Rect(1+FBackIslessFore,1,width+1-FBackIslessFore,height+1-prg));

//--- Back

   Pen.Color := ForeColor;
   Pen.Width := 1;
   Brush.Color := ForeColor;
   //  0  
   if progress>0 then
   begin
   //  
    case FKind of
      gkHorizontalBar:
        begin
          if prg > Width then prg := Width;
          {if prg > 0 then }FillRect(Rect(
            PaintRect.Left+1,PaintRect.Top+1,prg+1, Height+1));
        end;
      gkVerticalBar:
        begin
          if prg > Height then prg := Height;
          FillRect(Rect(PaintRect.Left+1,Height-prg+1, Width+1, height+1));
        end;
    end;
   end;

if  FAntiAliasLevel>0 then
    for i:=1 to FAntiAliasLevel do AntiAliasRect(AnImage,color);
  end;
AnImage.Canvas.unlock;
end;



procedure TTimeLine.SetGaugeKind(Value: TGaugeKind);
begin
  if Value <> FKind then
  begin
    FKind := Value;
    Refresh;
  end;
end;

procedure TTimeLine.SetForeColor(Value: TColor);
begin
  if Value <> FForeColor then
  begin
    FForeColor := Value;
    Refresh;
  end;
end;

procedure TTimeLine.SetBackColor(Value: TColor);
begin
  if Value <> FBackColor then
  begin
    FBackColor := Value;
    Refresh;
  end;
end;

procedure TTimeLine.SetMinValue(Value: integer);
begin
//  0
 FMinValue:=0;
end;

procedure TTimeLine.SetMaxValue(Value: integer);
begin
  if Value <> FMaxValue then
  begin
    if Value < FMinValue then
      if not (csLoading in ComponentState) then
        raise EInvalidOperation.CreateFmt(SOutOfRange, [FMinValue + 1, MaxInt]);
    FMaxValue := Value;
    if FCurValue > Value then FCurValue := Value;
    Refresh;
  end;
end;

procedure TTimeLine.SetProgress(Value: integer);
var t:integer;
begin
  if Value < 0 then Value := 0 else
   if Value > FMaxValue then  Value := FMaxValue;

  t:=GetprogressLen;
  if FCurValue <> Value then
  begin
    FCurValue := Value;
{ only refresh if  changed }
    // ,     ?
    if visible and (t<>GetProgressLen) then Refresh;
  end;
  if assigned(FOnChange) then OnChange(Self);
end;

procedure TTimeLine.SetAntiAliasLevel(const Value: integer);
begin
if FAntiAliasLevel <> Value then
 begin
  FAntiAliasLevel := Value;
  Refresh;
 end;
end;

procedure TTimeLine.CMMouseEnter(var Message: TMessage);
begin
FIsMouseEntering:=true;
if assigned(FOnMouseEnter) then OnMouseEnter(self);
end;

procedure TTimeLine.CMMouseLeave(var Message: TMessage);
begin
FIsMouseEntering:=false;
if assigned(FOnMouseLeave) then OnMouseLeave(self);
end;

procedure TTimeLine.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  FIsMouseEntering:=true;
  //if not self.Visible then exit;
  //if not(self.Owner as tcontrol).Visible then exit;
  if ToChangeMouseMove and (ssLeft in Shift) then
   begin
    mouseDown(mbLeft,shift,x,y);
   end;
  if assigned(FOnMouseMove) then
   OnMouseMove(self,shift,x,y,GetProgressFuture(x,y));
  inherited;
end;

procedure TTimeLine.MouseDown(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Var Res:integer;
begin
//try
 if FToChangeMouse and (shift>=FMouseShift)  then
  begin
   res:=GetProgressFuture(x,y);//   Progressa ?
   if Res<0 then res:=0 else if Res>MaxValue then Res:=MaxValue;
   if FCurValue <> res then progress:=res;
  end;

if assigned(FOnMouseDown) then
  OnMouseDown(self,shift,x,y,GetProgressFuture(x,y));

inherited;
// except
// Messagebox(0,' TTimeLine.MouseDown','',0);
// end;
end;

procedure TTimeLine.SetToChangeMouse(const Value: boolean);
begin
  FToChangeMouse := Value;
end;

procedure TTimeLine.SetMouseShift(const Value: TShiftState);
begin
  FMouseShift := Value;
end;

procedure TTimeLine.SetBackIslessFore(const Value: Integer);
begin
if FBackIslessFore <> Value then
 begin
  FBackIslessFore := Value;
  Refresh;
 end;
end;


procedure TTimeLine.DecStep;
begin
//SetProgress(FCurValue-fstep);
Progress:=FCurValue-fstep;
end;

procedure TTimeLine.IncStep;
begin
Progress:=Progress+fstep;
end;

procedure TTimeLine.SetToChangeMouseMove(const Value: boolean);
begin
  FToChangeMouseMove := Value;
end;

procedure TTimeLine.SetOnMouseMove(const Value: TMouseMoveEventEx);
begin
  FOnMouseMove := Value;
end;

function TTimeLine.GetProgressFuture(x,y:integer): integer;
begin
 case kind of
  gkHorizontalBar:Result := trunc(x*MaxValue/Width);
  gkVerticalBar  :Result := trunc((Height-y)*MaxValue/Height );
 end;
end;

destructor TTimeLine.Destroy;
begin
  TheCurrentImage.free;
  inherited;
end;

procedure TTimeLine.SetOnMouseDown(const Value: TMouseDownEventEx);
begin
  FOnMouseDown := Value;
end;

end.
